﻿
Imports FarPoint.CalcEngine
Imports FarPoint.Win

Public Class Form1

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)
        sht1.AddCustomFunction(New MyFormula(42))
        sht2.AddCustomFunction(New MyFormula(100))
        sht1.Cells(0, 0).Formula = "f(3)"
        sht2.Cells(0, 0).Formula = "f(3)"
    End Sub

End Class

Public Class MyFormula
    Inherits FunctionInfo

    Public Sub New(ByVal baseValue As Integer)
        _baseVal = baseValue
    End Sub

    Public Overloads Overrides Function Evaluate(ByVal args() As Object) As Object
        Return _baseVal + CInt(args(0))
    End Function

    Public Overrides ReadOnly Property MaxArgs() As Integer
        Get
            Return 1
        End Get
    End Property

    Public Overrides ReadOnly Property MinArgs() As Integer
        Get
            Return 1
        End Get
    End Property

    Public Overrides ReadOnly Property Name() As String
        Get
            Return "f"
        End Get
    End Property

    Private _baseVal As Integer

End Class